
; PicBasic Pro Compiler 2.33, (c) 1998, 2001 microEngineering Labs, Inc. All Rights Reserved. 
PM_USED			EQU	1

	INCLUDE	"16F84A.INC"


; Define statements.
#define		OSC				20	
#define		DEBUG_REG			PORTB	
#define		DEBUG_BIT			5	
#define		DEBUG_BAUD			9600
#define		DEBUG_MODE			1	

RAM_START       		EQU	0000Ch
RAM_END         		EQU	0004Fh
RAM_BANKS       		EQU	00001h
BANK0_START     		EQU	0000Ch
BANK0_END       		EQU	0004Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0213Fh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
T1              		EQU	RAM_START + 012h
T2              		EQU	RAM_START + 014h
FLAGS           		EQU	RAM_START + 016h
GOP             		EQU	RAM_START + 017h
RM1             		EQU	RAM_START + 018h
RM2             		EQU	RAM_START + 019h
RR1             		EQU	RAM_START + 01Ah
RR2             		EQU	RAM_START + 01Bh
_adc_value       		EQU	RAM_START + 01Ch
_ext_address     		EQU	RAM_START + 01Eh
_i               		EQU	RAM_START + 020h
_channel         		EQU	RAM_START + 022h
_eepromdata      		EQU	RAM_START + 023h
_int_address     		EQU	RAM_START + 024h
_PORTL           		EQU	PORTB
_PORTH           		EQU	PORTA
_TRISL           		EQU	TRISB
_TRISH           		EQU	TRISA
_adc_value_HIGHBYTE		EQU	_adc_value + 001h
_adc_value_LOWBYTE		EQU	_adc_value
#define _ADC_CS          	_PORTB_1
#define _ADC_SCLK        	_PORTB_0
#define _ADC_DATAOUT     	_PORTB_2
#define _ADC_DATAIN      	_PORTB_3
#define _G_SWITCH        	_PORTA_3
#define _SWITCH1         	_PORTA_2
#define _SWITCH3         	_PORTA_4
#define _EEPROM_SCLK     	_PORTA_0
#define _EEPROM_DATA     	_PORTA_1
#define _LED             	_PORTB_6
#define _PORTB_1         	PORTB, 001h
#define _PORTB_0         	PORTB, 000h
#define _PORTB_2         	PORTB, 002h
#define _PORTB_3         	PORTB, 003h
#define _PORTA_3         	PORTA, 003h
#define _PORTA_2         	PORTA, 002h
#define _PORTA_4         	PORTA, 004h
#define _PORTA_0         	PORTA, 000h
#define _PORTA_1         	PORTA, 001h
#define _PORTB_6         	PORTB, 006h

; Constants.
_T2400           		EQU	00000h
_T1200           		EQU	00001h
_T9600           		EQU	00002h
_T300            		EQU	00003h
_N2400           		EQU	00004h
_N1200           		EQU	00005h
_N9600           		EQU	00006h
_N300            		EQU	00007h
_OT2400          		EQU	00008h
_OT1200          		EQU	00009h
_OT9600          		EQU	0000Ah
_OT300           		EQU	0000Bh
_ON2400          		EQU	0000Ch
_ON1200          		EQU	0000Dh
_ON9600          		EQU	0000Eh
_ON300           		EQU	0000Fh
_MSBPRE          		EQU	00000h
_LSBPRE          		EQU	00001h
_MSBPOST         		EQU	00002h
_LSBPOST         		EQU	00003h
_LSBFIRST        		EQU	00000h
_MSBFIRST        		EQU	00001h
_CLS             		EQU	00000h
_HOME            		EQU	00001h
_BELL            		EQU	00007h
_BKSP            		EQU	00008h
_TAB             		EQU	00009h
_CR              		EQU	0000Dh
_unitOn          		EQU	00012h
_unitOff         		EQU	0001Ah
_unitsOff        		EQU	0001Ch
_lightsOn        		EQU	00014h
_lightsOff       		EQU	00010h
_dim             		EQU	0001Eh
_bright          		EQU	00016h
_BARO            		EQU	0008Eh
_XL              		EQU	000CEh
_TEMP            		EQU	000FEh
_EEPROM_READ     		EQU	000A1h
_EEPROM_WRITE    		EQU	000A0h
	INCLUDE	"ALTI_101.MAC"
	INCLUDE	"PBPPIC14.LIB"

	MOVE?CW	001h, _i
	LABEL?L	L00001	
	CMPGT?WCL	_i, 03Ch, L00002
	HIGH?T	_LED
	PAUSE?C	0FAh
	LOW?T	_LED
	PAUSE?C	0FAh
	NEXT?WCL	_i, 001h, L00001
	LABEL?L	L00002	

	LABEL?L	_check_switch_status	
	CMPT?TL	_SWITCH1, _begin_countdown
	CMPT?TL	_SWITCH3, _transmit_data
	GOTO?L	_check_switch_status

	LABEL?L	_begin_countdown	
	SLEEP?C	0012Ch
	CMPEQ?TCB	_SWITCH1, 000h, T1
	CMPEQ?TCB	_SWITCH3, 000h, T2
	LAND?BBL	T1, T2, _check_switch_status
	MOVE?CB	000h, _int_address
	MOVE?CW	001h, _i
	LABEL?L	L00003	
	CMPGT?WCL	_i, 00Ah, L00004
	MOVE?CB	_BARO, _channel
	GOSUB?L	_Read_ADC
	GOSUB?L	_Store_Ground_Data
	MOVE?CB	_XL, _channel
	GOSUB?L	_Read_ADC
	GOSUB?L	_Store_Ground_Data
	MOVE?CB	_TEMP, _channel
	GOSUB?L	_Read_ADC
	GOSUB?L	_Store_Ground_Data
	NEXT?WCL	_i, 001h, L00003
	LABEL?L	L00004	
	HIGH?T	_LED

	LABEL?L	_wait_for_launch	
	CMPEQ?TCL	_G_SWITCH, 000h, _wait_for_launch
	MOVE?CW	000h, _ext_address

	LABEL?L	_launch_detected	
	MOVE?CW	001h, _i
	LABEL?L	L00005	
	CMPGT?WCL	_i, 01555h, L00006
	MOVE?CB	_BARO, _channel
	GOSUB?L	_Read_ADC
	GOSUB?L	_Store_Flight_Data
	MOVE?CB	_XL, _channel
	GOSUB?L	_Read_ADC
	GOSUB?L	_Store_Flight_Data
	MOVE?CB	_TEMP, _channel
	GOSUB?L	_Read_ADC
	GOSUB?L	_Store_Flight_Data
	TOGGLE?T	_LED
	PAUSE?C	007h
	NEXT?WCL	_i, 001h, L00005
	LABEL?L	L00006	
	LOW?T	_LED
	END?	

	LABEL?L	_transmit_data	
	MOVE?CB	000h, _int_address
	MOVE?CW	001h, _i
	LABEL?L	L00007	
	CMPGT?WCL	_i, 00Ah, L00008
	READ?BB	_int_address, _adc_value_HIGHBYTE
	ADD?BCB	_int_address, 001h, _int_address
	READ?BB	_int_address, _adc_value_LOWBYTE
	ADD?BCB	_int_address, 001h, _int_address
	DEBUGCOUNT?C	000h
	DEBUGNUM?W	_adc_value
	DEBUGDEC?	
	DEBUG?C	009h
	READ?BB	_int_address, _adc_value_HIGHBYTE
	ADD?BCB	_int_address, 001h, _int_address
	READ?BB	_int_address, _adc_value_LOWBYTE
	ADD?BCB	_int_address, 001h, _int_address
	DEBUGCOUNT?C	000h
	DEBUGNUM?W	_adc_value
	DEBUGDEC?	
	DEBUG?C	009h
	READ?BB	_int_address, _adc_value_HIGHBYTE
	ADD?BCB	_int_address, 001h, _int_address
	READ?BB	_int_address, _adc_value_LOWBYTE
	ADD?BCB	_int_address, 001h, _int_address
	DEBUGCOUNT?C	000h
	DEBUGNUM?W	_adc_value
	DEBUGDEC?	
	DEBUG?C	00Dh
	NEXT?WCL	_i, 001h, L00007
	LABEL?L	L00008	
	DEBUG?C	00Dh
	MOVE?CW	000h, _ext_address
	MOVE?CW	001h, _i
	LABEL?L	L00009	
	CMPGT?WCL	_i, 01555h, L00010
	GOSUB?L	_Read_EEPROM
	MOVE?BB	_eepromdata, _adc_value_HIGHBYTE
	ADD?WCW	_ext_address, 001h, _ext_address
	GOSUB?L	_Read_EEPROM
	MOVE?BB	_eepromdata, _adc_value_LOWBYTE
	ADD?WCW	_ext_address, 001h, _ext_address
	DEBUGCOUNT?C	000h
	DEBUGNUM?W	_adc_value
	DEBUGDEC?	
	DEBUG?C	009h
	GOSUB?L	_Read_EEPROM
	MOVE?BB	_eepromdata, _adc_value_HIGHBYTE
	ADD?WCW	_ext_address, 001h, _ext_address
	GOSUB?L	_Read_EEPROM
	MOVE?BB	_eepromdata, _adc_value_LOWBYTE
	ADD?WCW	_ext_address, 001h, _ext_address
	DEBUGCOUNT?C	000h
	DEBUGNUM?W	_adc_value
	DEBUGDEC?	
	DEBUG?C	009h
	GOSUB?L	_Read_EEPROM
	MOVE?BB	_eepromdata, _adc_value_HIGHBYTE
	ADD?WCW	_ext_address, 001h, _ext_address
	GOSUB?L	_Read_EEPROM
	MOVE?BB	_eepromdata, _adc_value_LOWBYTE
	ADD?WCW	_ext_address, 001h, _ext_address
	DEBUGCOUNT?C	000h
	DEBUGNUM?W	_adc_value
	DEBUGDEC?	
	DEBUG?C	00Dh
	TOGGLE?T	_LED
	NEXT?WCL	_i, 001h, L00009
	LABEL?L	L00010	
	LOW?T	_LED
	END?	

	LABEL?L	_Read_ADC	
	LOW?T	_ADC_CS
	SHIFTDATA?T	_ADC_DATAOUT
	SHIFTCLOCK?T	_ADC_SCLK
	SHIFTMODE?C	_MSBFIRST
	SHIFTOUT?BC	_channel, 008h
	SHIFTDATA?T	_ADC_DATAIN
	SHIFTCLOCK?T	_ADC_SCLK
	SHIFTMODE?C	_MSBPOST
	SHIFTIN?WC	_adc_value, 00Ch
	HIGH?T	_ADC_CS
	RETURN?	

	LABEL?L	_Store_Ground_Data	
	WRITE?BB	_int_address, _adc_value_HIGHBYTE
	ADD?BCB	_int_address, 001h, _int_address
	WRITE?BB	_int_address, _adc_value_LOWBYTE
	ADD?BCB	_int_address, 001h, _int_address
	RETURN?	

	LABEL?L	_Store_Flight_Data	
	MOVE?BB	_adc_value_HIGHBYTE, _eepromdata
	GOSUB?L	_Write_EEPROM
	ADD?WCW	_ext_address, 001h, _ext_address
	MOVE?BB	_adc_value_LOWBYTE, _eepromdata
	GOSUB?L	_Write_EEPROM
	ADD?WCW	_ext_address, 001h, _ext_address
	RETURN?	

	LABEL?L	_Write_EEPROM	
	I2CDATA?T	_EEPROM_DATA
	I2CCLOCK?T	_EEPROM_SCLK
	I2CWRITE?C	_EEPROM_WRITE
	I2CWRITE?W	_ext_address
	I2CWRITES?B	_eepromdata
	PAUSE?C	005h
	RETURN?	

	LABEL?L	_Read_EEPROM	
	I2CDATA?T	_EEPROM_DATA
	I2CCLOCK?T	_EEPROM_SCLK
	I2CWRITE?C	_EEPROM_READ
	I2CWRITE?W	_ext_address
	I2CREADS?B	_eepromdata
	PAUSE?C	005h
	RETURN?	

	END
